%% parameters and image generation
clc
close all

Gup = -0.5; %Gup=Parameters.yedges(end);%Gup = 3e-1;
Gdown = -6; %Gdown=Parameters.yedges(1);%Gdown = 2e-6;
Xmin = -0.25;%Xmin = Parameters.xedges(1);
Xmax = 1.5;%Xmax = Parameters.xedges(end);
Xbins = 25;
Ybins = 32;
up1D = 0.5; down1D = -7; bins1D = 0; %parameters for the 1D histogram to add to the image

%% Image generation

%reduced dimensionality grid
%find the limits
tic

% [~,xidx(1)] = min(abs((Parameters.xedges - Xmin)));
% [~,xidx(2)] = min(abs((Parameters.xedges - Xmax)));
% [~,yidx(1)] = min(abs((Parameters.yedges - Gdown))); %note that yedges has values in opposite order, so the min and max positions are swapped here
% [~,yidx(2)] = min(abs((Parameters.yedges - Gup)));
% [~,idx1D(1)] = min(abs((Parameters.yedges - down1D))); %note that yedges has values in opposite order, so the min and max positions are swapped here
% [~,idx1D(2)] = min(abs((Parameters.yedges - up1D)));
% 
% xstep = round((xidx(2)-xidx(1))/Xbins);
% ystep = round((yidx(2)-yidx(1))/Ybins);
% step1D = round((idx1D(2)-idx1D(1))/bins1D);
% 
% 
% 
% %compute the new edge vectors
% nyedges = Parameters.yedges(yidx(1):ystep:yidx(2));
% nxedges = Parameters.xedges(xidx(1):xstep:xidx(2));
% try
%     edges1D = Parameters.yedges(idx1D(1):step1D:idx1D(2));
% catch
%     edges1D = [];
% end

%[images,X] = traceImages(G,nxedges,nyedges, edges1D);

[images,X,nxedges,nyedges] = traceImagesbins(G,[Xbins Ybins],bins1D, [Xmin Xmax],[Gdown Gup], [down1D up1D]);

toc

%plot_2D(images{50},[],Xmin-0.5,Xmax+1,Gdown,Gup,nxedges,nyedges)
%plotimage(nxedges,nyedges,images{50},cmap);

%% Test plots

for i = 1:15
    offset = floor(rand * length(images));
    plotimage(nxedges(1:end-1),nyedges(1:end-1),images{offset}',cmap);
    title(['Trace ' num2str(offset+i)]);
end

%% clustering 
tic

k=5;

class_idx = kmeans(X,k,'Display','final','Replicates',10);
toc

%% Make histograms and plot
tic
for i=1:k
    Class(i).histo2D = zeros(Parameters.Ybin,Parameters.Xbin);
    for j = 1:length(class_idx)
        if class_idx(j)== i
            Class(i).histo2D = Class(i).histo2D + hist2(G(j).d_breaking,G(j).g_breaking, Parameters.xedges,Parameters.yedges);
        end
    end
    Class(i).histo1D = sum(Class(i).histo2D,2);
    figure('Position',[500 150 1000 750],'PaperPosition',[0.6 5 16 20])
        h1=subplot(1,2,1);
        plot_2D(Class(i).histo2D,'coupled',Parameters.Dmin,Parameters.Dmax,Parameters.Gmin,Parameters.Gmax,Parameters.xedges,Parameters.yedges);
        colormap(gca,cmap)
        h2=subplot(1,2,2);
        Fits(i).line=0;
        Fits(i).result=0;
        plot_1D(Class(i).histo1D,Fits(i),Parameters)
        hor2ver_1Dfit()
        set(gca,'xticklabel',[])
        set(gca,'yticklabel',[])
        ylabel('Counts [a.u.]')
        xlabel([])
        set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
        set(findall(gcf,'type','axes'),'fontsize',20,'fontweight','normal')
        set(h1,'Position',[0.13 0.11 0.37466 0.815])
        set(h2,'Position',[0.5425 0.11 0.37466 0.815])
        f = gcf;
        oldunits = get(f,'Units');
        set(f, 'PaperUnits', 'centimeters', 'Units', 'centimeters');
        figpos = get(f, 'Position');
        f.PaperPositionMode = 'auto';
        set(gcf, 'PaperSize', figpos(3:4), 'Units', oldunits);
        title(['Class ' num2str(i)])
end
toc