
close all
tic
k=2;
Gup =3e-1;
Gdown = 1e-6;

[tmp,idx_up] = min(abs(Parameters.yedges - Gup));
[tmp,idx_down] = min(abs(Parameters.yedges - Gdown));

X = Histograms(1).histo1Dsingle(:,idx_down:idx_up);

[class_idx, centroids] = kmeans(X,k,'Display','final','Replicates',10);


for i=1:k
    Class(i).histo2D = zeros(Parameters.Ybin,Parameters.Xbin);
    for j = 1:length(class_idx)
        if class_idx(j)== i
            Class(i).histo2D = Class(i).histo2D + hist2(G(j).d_breaking,G(j).g_breaking, Parameters.xedges,Parameters.yedges);
        end
    end
    Class(i).histo1D = sum(Class(i).histo2D,2);
    figure('Position',[500 150 1000 750],'PaperPosition',[0.6 5 16 20])
%     plot_2D(Class(i).histo2D,[],Parameters.Dmin,Parameters.Dmax,Parameters.Gmin,Parameters.Gmax,Parameters.xedges,Parameters.yedges);
%     colormap(cmap);
        h1=subplot(1,2,1);
        plot_2D(Class(i).histo2D,'coupled',Parameters.Dmin,Parameters.Dmax,Parameters.Gmin,Parameters.Gmax,Parameters.xedges,Parameters.yedges);
        colormap(gca,cmap)
        h2=subplot(1,2,2);
        Fits(i).line=0;
        Fits(i).result=0;
        plot_1D(Class(i).histo1D,Fits(i),Parameters)
        hor2ver_1Dfit()
        set(gca,'xticklabel',[])
        set(gca,'yticklabel',[])
        ylabel('Counts [a.u.]')
        xlabel([])
        set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
        set(findall(gcf,'type','axes'),'fontsize',20,'fontweight','normal')
        set(h1,'Position',[0.13 0.11 0.37466 0.815])
        set(h2,'Position',[0.5425 0.11 0.37466 0.815])
        f = gcf;
        oldunits = get(f,'Units');
        set(f, 'PaperUnits', 'centimeters', 'Units', 'centimeters');
        figpos = get(f, 'Position');
        f.PaperPositionMode = 'auto';
        set(gcf, 'PaperSize', figpos(3:4), 'Units', oldunits);
        title(['Class ' num2str(i)])
end
toc