%% PCA plot using 1D histogram
%close all
clc

[coeff,score,latent]=pca(X);

%% Figures
figure
box on
biplot(coeff(:,1:3),'scores',score(1:1000,1:3))

if exist('class_idx')
    limit = 10000;
    col = linspecer(k);
    figure
    box on
    scatter3(score(1:limit,1),score(1:limit,2),score(1:limit,3),20,col(class_idx(1:limit),:))
    title('PCA 1 to 3')
    
    figure
    box on
    scatter3(score(1:limit,2),score(1:limit,3),score(1:limit,4),20,col(class_idx(1:limit),:))
    title('PCA 2 to 4')

    figure
    box on
    gscatter(score(1:limit,1),score(1:limit,2),class_idx(1:limit),col)
    title('PCA 1,2')
    
    figure
    box on
    gscatter(score(1:limit,1),score(1:limit,3),class_idx(1:limit),col)
    title('PCA 1,3')
    
    figure
    box on
    gscatter(score(1:limit,2),score(1:limit,3),class_idx(1:limit),col)
    title('PCA 2,3')
end

%% Evaluate Variance per component
resval = latent./sum(latent);
cumresval=cumsum(latent)./sum(latent); %cumulative residual valence

figure
box on
subplot(2,1,1)
plot(resval)
ylabel('Residual valence per component')
subplot(2,1,2)
plot(cumresval)
ylabel('Total residual valence')
xlabel('Principal component #')


