%% PCA interactive plot to select components
clc
%close all

directions = [1 2 3];

[coeff,score,latent]=pca(X);

col = linspecer(k);

f = figure('position',[100 100 1000 1000]);
ax = axes('Parent',f,'position',[0.3 0.1 0.5 0.5]);
scatter3(score(:,directions(1)), score(:,directions(2)), score(:,directions(3)),20,col(class_idx,:));
xlabel(['PCA ' num2str(directions(1))]);
ylabel(['PCA ' num2str(directions(2))]);
zlabel(['PCA ' num2str(directions(3))]);

ax1 = axes('Parent',f,'position',[0.1 0.65 0.25 0.25]);
gscatter(score(:,1),score(:,2),class_idx,col);
xlabel(['PCA ' num2str(directions(1))]);
ylabel(['PCA ' num2str(directions(2))]);

ax2 = axes('Parent',f,'position',[0.4 0.65 0.25 0.25]);
gscatter(score(:,1),score(:,3),class_idx,col);
xlabel(['PCA ' num2str(directions(1))]);
ylabel(['PCA ' num2str(directions(3))]);

ax3 = axes('Parent',f,'position',[0.7 0.65 0.25 0.25]);
gscatter(score(:,2),score(:,3),class_idx,col);
xlabel(['PCA ' num2str(directions(2))]);
ylabel(['PCA ' num2str(directions(3))]);

a = uicontrol('Parent',f,'Style','popupmenu','position',[20 165 75 20],'Min',1,'Max',1,'value',1);
ta = uicontrol('Parent',f,'Style','text','position',[95 165 75 20],'String',' = X axis' );
b = uicontrol('Parent',f,'Style','popupmenu','position',[20 135 75 20],'Min',1,'Max',1,'value',2);
tb = uicontrol('Parent',f,'Style','text','position',[95 135 75 20],'String',' = Y axis' );
c = uicontrol('Parent',f,'Style','popupmenu','position',[20 105 75 20],'Min',1,'Max',1,'value',3);
tc = uicontrol('Parent',f,'Style','text','position',[95 105 75 20],'String',' = Z axis' );

for i=1:size(score,2)
    str{i} = ['PCA ' num2str(i)];
end
a.String = str;
b.String = str;
c.String = str;

a.Callback = @(src,event) aselection(src,event,b,c,score,col,class_idx,ax,ax1,ax2);
b.Callback = @(src,event) bselection(src,event,a,c,score,col,class_idx,ax,ax1,ax3);
c.Callback = @(src,event) cselection(src,event,a,b,score,col,class_idx,ax,ax2,ax3);

function aselection(src,event,b,c,score,col,class_idx,par,par1,par2)
    direction = src.Value;
    p1=scatter3(score(:,direction), score(:,b.Value), score(:,c.Value),20,col(class_idx,:),'Parent',par);
    p2=gscatter(par1,score(:,direction),score(:,b.Value),class_idx,col);
    p3=gscatter(par2,score(:,direction),score(:,c.Value),class_idx,col);
    
    par.XLabel.String = ['PCA ' num2str(direction)];
    par.YLabel.String = ['PCA ' num2str(b.Value)];
    par.ZLabel.String = ['PCA ' num2str(c.Value)];
    par1.XLabel.String = ['PCA ' num2str(direction)];
    par1.YLabel.String = ['PCA ' num2str(b.Value)];
    par2.XLabel.String = ['PCA ' num2str(direction)];
    par2.YLabel.String = ['PCA ' num2str(c.Value)];
end

function bselection(src,event,a,c,score,col,class_idx,par,par1,par2)
    direction = src.Value;
    scatter3(score(:,a.Value), score(:,direction), score(:,c.Value),20,col(class_idx,:),'Parent',par);
    gscatter(par1,score(:,a.Value),score(:,direction),class_idx,col);
    gscatter(par2,score(:,direction),score(:,c.Value),class_idx,col);
    
    par.XLabel.String = ['PCA ' num2str(a.Value)];
    par.YLabel.String = ['PCA ' num2str(direction)];
    par.ZLabel.String = ['PCA ' num2str(c.Value)];
    par1.XLabel.String = ['PCA ' num2str(a.Value)];
    par1.YLabel.String = ['PCA ' num2str(direction)];
    par2.XLabel.String = ['PCA ' num2str(direction)];
    par2.YLabel.String = ['PCA ' num2str(c.Value)];

end

function cselection(src,event,a,b,score,col,class_idx,par,par1,par2)
    direction = src.Value;
    scatter3(score(:,a.Value), score(:,b.Value), score(:,direction),20,col(class_idx,:),'Parent',par);
    gscatter(par1,score(:,a.Value),score(:,direction),class_idx,col);
    gscatter(par2,score(:,b.Value),score(:,direction),class_idx,col);
  
    par.XLabel.String = ['PCA ' num2str(a.Value)];
    par.YLabel.String = ['PCA ' num2str(b.Value)];
    par.ZLabel.String = ['PCA ' num2str(direction)];
    par1.XLabel.String = ['PCA ' num2str(a.Value)];
    par1.YLabel.String = ['PCA ' num2str(direction)];
    par2.XLabel.String = ['PCA ' num2str(b.Value)];
    par2.YLabel.String = ['PCA ' num2str(direction)];
end