function [images,vectors,nxedges,nyedges] = traceImages(G,xedges,yedges,Xlim,Ylim,Xbins,Ybins)
%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here

[~,xidx(1)] = min(abs((xedges - Xlim(1))));
[~,xidx(2)] = min(abs((xedges - Xlim(2))));
[~,yidx(1)] = min(abs((yedges - Ylim(2)))); %note that yedges has values in opposite order, so the min and max positions are swapped here
[~,yidx(2)] = min(abs((yedges - Ylim(1))));

xstep = round((xidx(2)-xidx(1))/Xbins);
ystep = round((yidx(2)-yidx(1))/Ybins);
nyedges = yedges(yidx(1):ystep:yidx(2));
nxedges = xedges(xidx(1):xstep:xidx(2));
sz_vector = length(nxedges)*length(nyedges);
vectors = zeros(length(G),sz_vector);


for i=1:length(G)
    tmphist = hist2(G(i).d_breaking,G(i).g_breaking, xedges,yedges); 
    tmphist = tmphist(yidx(1):yidx(2),xidx(1):xidx(2));
    [Y,X] = ndgrid(yedges(yidx(1):yidx(2)),xedges(xidx(1):xidx(2))); %create original grid for interpolation
    [nY,nX] = ndgrid(nyedges,nxedges); %create end grid for the final image
    interp = griddedInterpolant(Y,X,tmphist); %create an interpolation of the original matrix
    images{i} = interp(nY,nX); %evaluate the interpolation on the image grid
    %vectors(:,i)=reshape(images{i},[],1); %This stacks each colums of the figure to make a vector
    vectors(i,:)=reshape(images{i}',[],1); %This stacks each row of the figure to make a vector
end

