function [images,vectors,xedges,yedges,edges1D] = traceImagesbins(G,bins2D,bins1D,Xlim,Ylim,Lim1D)
%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here

[~ ,xedges,yedges] = histcounts2(G(1).d_breaking,log10(G(1).g_breaking), bins2D,'XBinlimits',Xlim,'YbinLimits',Ylim);

if bins1D == 0
    sz_vector = (length(xedges)-1)*(length(yedges)-1);
    vectors = zeros(length(G),sz_vector);
    for i=1:length(G)
        images{i} = histcounts2(G(i).d_breaking,log10(G(i).g_breaking),bins2D,'XBinlimits',Xlim,'YbinLimits',Ylim); 
        %vectors(:,i)=reshape(images{i},1,[]); %This stacks each colums of the figure to make a vector
        vectors(i,:)=reshape(images{i},1,[]); %This stacks each row of the figure to make a vector (actually it takes columns of the matrix,but the matrix is the transpose of the image we actually want to see) 
    end
else
    [~ ,edges1D] = histcounts(log10(G(1).g_breaking),bins1D,'BinLimit',Lim1D);
    sz_vector = (length(xedges)-1)*(length(yedges)-1) + length(edges1D)-1;
    vectors = zeros(length(G),sz_vector);
    for i=1:length(G)
        images{i} = histcounts2(G(i).d_breaking,log10(G(i).g_breaking), bins2D,'XBinlimits',Xlim,'YbinLimits',Ylim); 
        histo1D = histcounts(log10(G(i).g_breaking),bins1D,'BinLimit',Lim1D);
        %vectors(:,i)=[reshape(images{i},1,[]) histo1D]; %This stacks each colums of the figure to make a vector
        vectors(i,:)=[reshape(images{i},1,[]), histo1D]; %This stacks each row of the figure to make a vector (actually it takes columns of the matrix,but the matrix is the transpose of the image we actually want to see) 
    end
end

