function [Length_histo] = G_segment(G,Files,Parameters,G_max,G_min,G_bin)
%Takes data, segment it in conductance sections, and calculate the plateau
%length in such sections

G_max = 0;
G_min = -6;
G_bin = 10;

Length_segments = zeros(G_bin-1,Files.plotend-Files.plotstart+1);

G_segments= linspace(G_max,G_min,G_bin);
for j=1:(length(G_segments)-1)
    Ltemp = zeros(1,length(Files.plotstart:Files.plotend));
    for i = Files.plotstart:Files.plotend
        Ltemp(i) = length_calc_selectG(G(i).d_breaking,G(i).g_breaking,10^G_segments(1),10^G_segments(j+1),Parameters);
    end
    Length_segments(j,:)=Ltemp;
    Length_histo(j,:)= hist(Ltemp,Parameters.Ledges);
end

figure
hold on

for i=1:size(Length_histo,1)
    plot(Parameters.Ledges,Length_histo(i,:))
end
legend