function line = GetFit(Parameters,FitResults)
%% functions
g = @(x,par)par(3)*exp(-((x-par(2))./(0.6005615.*par(4))) .^2);

%% Variables
PlotRange = Parameters.yedges;
[NumPeaks,~] = size(FitResults);

if FitResults==0
    line=0;
    NumPeaks = 0;
else
    if NumPeaks>1
        line = cell(1,NumPeaks+1);
    else
        line = cell(1,NumPeaks);
    end
end

%% Lines
for i = 1:NumPeaks
  line{i} = g(log10(PlotRange),FitResults(i,:));
end
   
if NumPeaks>1
    line{end} = 0;
    for i=1:NumPeaks
        line{end} = line{end}+line{i};
    end
end

end