function [Kmeans,Files,Parameters] = LoadGKmeans(Kmeans,Parameters,Bools,name)

%% Load .mat files
load([Parameters.KPath,'list_d_selected.mat'])
load([Parameters.KPath,'list_G_selected.mat'])
load([Parameters.KPath,'cluster.mat'])
if Bools.loadParameters
  load([Parameters.KPath,'Parameters.mat'])
  Xmax = double(Dmax);
end
Nfiles = length(list_G_selected);
if Bools.Save && ~exist(Parameters.savepath,'dir')
    mkdir(Parameters.savepath);
end
indexTmp = length(Kmeans);
Clusters_num = (Kmeans_data(1,:))';
N_classes = max(Clusters_num)+1;

%% Read files and assign to Kmeans struct
disp('Reading data');
for j=1:N_classes
    Kmeans(indexTmp+j).d_breaking = list_d_selected(Clusters_num==j-1)';
    Kmeans(indexTmp+j).g_breaking = list_G_selected(Clusters_num==j-1)';
    Kmeans(indexTmp+j).class = [name num2str(j)];
end

%% Change scale conductance
for j=1:N_classes
    for i=1:length(Kmeans(indexTmp+j).g_breaking)
        Kmeans(indexTmp+j).g_breaking{i} = 10.^(Kmeans(indexTmp+j).g_breaking{i});
        %Kmeans(j).g_breaking{i} = Kmeans(j).g_breaking{i};
    end
end

%% Restricted option
if Bools.Restricted
    plotstart = Parameters.RestrictedRange(1);
    plotend = Parameters.RestrictedRange(2);
    Nplotted = plotend-plotstart+1;
else
    plotstart = 1;
    plotend = Nfiles;
    Nplotted = Nfiles;
end

%% Outputs
Files.plotstart     = plotstart;
Files.plotend       = plotend;
Files.Nplotted      = Nplotted;
Files.Nfiles        = Nfiles;
Files.motor         = 0;
Files.piezo         = 1;
if Bools.loadParameters
    Parameters.attenuation  = attenuation;
    Parameters.binsperX     = binsperX;
    Parameters.binsperY     = binsperY;
    Parameters.Dmin         = Dmin;
    Parameters.Dmax         = Dmax;
    Parameters.Gmin         = Gmin;
    Parameters.Gmax         = Gmax;
    Parameters.Xmax         = Xmax;
end
end
