function SaveKmeans(Parameters,H,Bools,Plots,Histograms)

if ~exist([Parameters.savepath 'figures/'],'dir')
    mkdir([Parameters.savepath 'figures/']);
end
for i=1:length(H)
    if Plots.Hist2D && i<=length(Histograms)
        saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 2D ' Histograms(i).name '.png'])
        saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 2D ' Histograms(i).name '.fig'])
        if Bools.vectorFigures
            ax = findall(H{i},'type','axes');
            pl = findobj(H{i}, 'type', 'surface');
            pos1 = ax.Position;
            cb = getappdata(ax,'ColorbarPeerHandle');

            set(ax,'Visible','on');
            set(cb,'Visible','on');
            set(pl,'Visible','off');
            saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 2D ' Histograms(i).name '_axes.eps'],'epsc')

            set(ax,'Visible','off');
            set(cb,'Visible','off');
            set(pl,'Visible','on');
            % set(lin,'Visible','on');
            set(ax,'Position',pos1)
            saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 2D ' Histograms(i).name '_plot.tif'])

            set(ax,'Position',pos1)
            set(ax,'Visible','on');
            set(cb,'Visible','on');
            set(pl,'Visible','on');
            %print(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 2D ' Histograms(i).name],'-dpdf','-r0')
        end
    elseif Plots.Hist1D && i<=2*length(Histograms) && i>length(Histograms)
        saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 1D ' Histograms(i-length(Histograms)).name '.png'])
        saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 1D ' Histograms(i-length(Histograms)).name '.fig'])
        if Bools.vectorFigures
            saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 1D ' Histograms(i-length(Histograms)).name '.eps'],'epsc')
        end
    elseif Plots.Overview && i<=3*length(Histograms) && i>2*length(Histograms)
        saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' Overview ' Histograms(i-2*length(Histograms)).name '.png'])
        saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' Overview ' Histograms(i-2*length(Histograms)).name '.fig'])
        if Bools.vectorFigures
            ax = findall(H{i},'type','axes');
            pl = findobj(H{i}, 'type', 'surface');
            lin = findobj(H{i}, 'type', 'line');
            ar = findobj(H{i}, 'type', 'Area');
            ptc = findobj(H{i}, 'type', 'Patch');
            cb = findall(H{i},'type','ColorBar');
            %pos1 = ax(2).Position;

            set(ax,'Visible','on');
            set(cb,'Visible','on');
            set(lin,'Visible','off');
            set(ptc,'Visible','off');
            set(ar,'Visible','off');
            set(pl,'Visible','off');
            saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' Overview ' Histograms(i-2*length(Histograms)).name '_axes.eps'],'epsc')
            
            set(ax,'Visible','off');
            set(cb,'Visible','off');
            set(lin,'Visible','on');
            set(ar,'Visible','off');
            set(ptc,'Visible','off');
            set(pl,'Visible','off');
            saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' Overview ' Histograms(i-2*length(Histograms)).name '_lines.eps'],'epsc')
            
            set(ax,'Visible','off');
            set(cb,'Visible','off');
            set(pl,'Visible','on');
            set(ptc,'Visible','on');
            set(lin,'Visible','off');
            set(ar,'Visible','on');
            saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' Overview ' Histograms(i-2*length(Histograms)).name '_plot.tif'])

            set(ax,'Visible','on');
            set(cb,'Visible','on');
            set(pl,'Visible','on');
            set(ptc,'Visible','on');
            set(lin,'Visible','on');
            set(ar,'Visible','on');
            %print(H{i},[Parameters.savepath 'figures/' Parameters.filename ' Overview ' Histograms(i-2*length(Histograms)).name],'-dpdf','-r0')
        end
    elseif Plots.HistL && i<=4*length(Histograms) && i>3*length(Histograms)
        saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' L ' Histograms(i-3*length(Histograms)).name '.png'])
        saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' L ' Histograms(i-3*length(Histograms)).name '.fig'])
        if Bools.vectorFigures
            saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' L ' Histograms(i-3*length(Histograms)).name '.eps'],'epsc')
        end
    elseif Plots.Hist2DCC && i<=5*length(Histograms) && i>4*length(Histograms)
        saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 2DCC ' Histograms(i-4*length(Histograms)).name '.png'])
        saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 2DCC ' Histograms(i-4*length(Histograms)).name '.fig'])
        if Bools.vectorFigures
            saveas(H{i},[Parameters.savepath 'figures/' Parameters.filename ' 2DCC ' Histograms(i-4*length(Histograms)).name '.eps'],'epsc')
        end
    end
end

filename = [Parameters.savepath Parameters.filename];
if Bools.Close
    close all
    evalin( 'base', 'clear H' )
    evalin('base', sprintf('save(''%s.mat'')', filename))
%     save([Parameters.savepath Parameters.filename '.mat'], '-v7.3')
else
    evalin('base', sprintf('save(''%s.mat'')', filename))
end

end