function Length = length_calc(d_breaking,g_breaking,Parameters)
%This function calculate the length of a trace/plateau given the upper and
%lower limits to consider (Gmax and Gmin respectively)
%d_breaking and g_breaking are the data arrays of a SINGLE trace

%finds first and last point contained in the specified range
try
    xstart = find(g_breaking<Parameters.LGup,1,'first');
    xend = find(g_breaking>Parameters.LGlow,1,'last');
catch
    xstart = NaN;
    xend = NaN;
end
%calculate trace length between the two points
if ~isempty(xstart) && ~isempty(xend)
    if ~isnan(xstart)&& ~isnan(xend)
        Length = d_breaking(xend)-d_breaking(xstart);
        if Length <0
            Length =0;
        end
    end
else
    if g_breaking(1) == Parameters.noiselvl
           Length = NaN;
    else 
        Length = 0;        
    end
end
    
end


