function plot_1D_vertical(hist1D,Fits,Parameters)
   yedges = Parameters.yedges;
   Gmin = Parameters.Gmin;
   Gmax = Parameters.Gmax;


   PlotRange = yedges;
   set(gca,'Position',[0.13 0.125 0.775 0.8]);

   aaa = area(yedges,hist1D,'FaceColor',[0 0.4470 0.7410]);
	uistack(aaa,'bottom');
	set(gca,'xscale','log')
   hold on;
   
   % fitted lines
   if iscell(Fits.line)
       for i = 1:length(Fits.line)
           if i>1 && i==length(Fits.line)
               semilogx(PlotRange,Fits.line{i},'k.-')%peaksum
           else
               semilogx(PlotRange,Fits.line{i},'r--')%peaksum
           end
       end
   end

   xlabel('Conductance (G_0)')
   ylabel('Counts / trace')
   set(gca,'fontsize',20,'fontweight','normal')
   set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
   set(gca,'linewidth',1.5,'box','on')
   set(gcf,'color','white')
   set(gca,'TickLength',[0.02, 0.002])
   
   pos2 = find(min(abs(yedges - 3)) == abs(yedges - 3));
   pos1 = find(min(abs(yedges - 2e-6)) == abs(yedges - 2e-6));
   MAX = max(hist1D(pos1:pos2));
   set(gca,'Ylim',[0 1.05*MAX])
   set(gca,'Xlim',[Gmin  Gmax])
   set(gca,'XTick',[1e-8 1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
    view (90,-90);
end

	
