function plot_L(histL,Fits,Parameters, col)
   Ledges = Parameters.Ledges;
   Lmin = 0;
   Lmax = Parameters.Lmax;


   PlotRange = Ledges;
   set(gca,'Position',[0.13 0.125 0.775 0.8]);

   aaa = area(Ledges,histL,'FaceColor',col);
	uistack(aaa,'bottom');
	
   hold on;
   
   % fitted lines
   if iscell(Fits.line)
       for i = 1:length(Fits.line)
           if i>1 && i==length(Fits.line)
               plot(PlotRange,Fits.line{i},'k.-','linewidth',2)%peaksum
           else
               plot(PlotRange,Fits.line{i},'r--','linewidth',2)%peaksum
           end
       end
   end

   xlabel('Length [nm]')
   ylabel('Counts [a.u.]')
   set(gca,'fontsize',20,'fontweight','normal')
   set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
   set(gca,'linewidth',1.5,'box','on')
   set(gcf,'color','white')

   pos2 = find(min(abs(Ledges - 3)) == abs(Ledges - 3));
   pos1 = find(min(abs(Ledges - 2e-6)) == abs(Ledges - 2e-6));
   MAX = max(histL(pos1:pos2));
   set(gca,'Ylim',[0 1.05*MAX])
   set(gca,'Xlim',[Lmin  Lmax])
   %set(gca,'XTick',[1e-8 1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])

end

	
