%% Loads the fitting results from tha .mat file and creates a table

close all
clear
clc

path = {'C:\Data\OPE3s\OPE3-diSAc\Sample 1\Molecule\15-19\scan190706_0\new scripts\3\',...
        'C:\Data\OPE3s\OPE3-diSAc\Sample 2\Molecule\16-20\scan190709_5\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Naphtalene\Sample 5\Molecule\13-17\scan190628_11\new scripts\3 double fit\',...
        'C:\Data\OPE3s\OPE3 - Naphtalene\Sample 6\Molecule\13-17\scan190704_12\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Naphtalene\Sample 5\Molecule\13-17\scan190629_0\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Antracene\Sample 3\Molecule\3-7\scan190516_3\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Antracene\Sample 4\Molecule\15-19\scan190711_4\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Antracene\Sample 1\Molecule\2-6\scan190510_11\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Antracene\Sample 3\Molecule\2-6\scan190515_43\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - TetraCene\Sample 1\Molecule\3-7\scan190507_8\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - TetraCene\Sample 3\Molecule\15-19\scan190723_13\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - TetraCene\Sample 1\Molecule\3-7\scan190508_2\new scripts\3\',... %'C:\Data\OPE3s\OPE3 - TetraCene\Sample 1\Molecule\3-7 v2\scan190509_0\new scripts\3\',... it's at 100 V/s
        'C:\Data\OPE3s\OPE3 - Pentacene\Sample 1 piezo\molecule\16-20\scan190222_20\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Pentacene\Sample 1 LC\Molecule\15-19\scan190702_14\new scripts\3\'};
name = {'scan190706_0','scan190709_5',...
        'scan190628_11','scan190704_12','scan190629_0',...
        'scan190516_3','scan190711_4','scan190510_11','scan190515_43',...
        'scan190507_8','scan190723_13','scan190508_2',...%'scan190509_0',...
        'scan190222_20','scan190702_14'};
    
high_class_idx = [3,4,...
             3,2,4,...
             3,3,2,2,...
             3,4,4,...%4,...
             2,2];
low_class_idx = [4,2,...
             4,4,3,...
             4,4,4,4,...
             4,3,6,...%3,...
             4,5];

N_histo = [2 3 4 3 2]; %number of histograms for each molecule
Molecule = {'OPE3','NP','AC','TC','PC'};

piezo_speed = 200; %V/s piezo speed used in measurements

Save = 1;
savepath = 'C:/Data/OPE3s/Tables/all/';

%% Load the saved struct

counter =1;
high_G = table('Size',[length(path) 5],'VariableTypes',{'cell','double','double','double','double'},'VariableNames',{'Name','Conductance','FWHM','Length','Yield'});
low_G = table('Size',[length(path) 5],'VariableTypes',{'cell','cell','cell','cell','double'},'VariableNames',{'Name','Conductance','FWHM','Length','Yield'});
low_G_single = table('Size',[length(path) 5],'VariableTypes',{'cell','double','double','double','double'},'VariableNames',{'Name','Conductance','FWHM','Length','Yield'});
raw_G = table('Size',[length(path) 5],'VariableTypes',{'cell','double','double','double','double'},'VariableNames',{'Name','Conductance','FWHM','Length','Speed'});


for i=1:length(Molecule)
    for j=1:N_histo(i)
        path{counter}=strrep(path{counter},'\','/');
        load([path{counter} name{counter} '.mat'],'Plateau_info')
        load([path{counter} name{counter} '.mat'],'Parameters')
        
        %Calculate measurement electrode speed
        raw_G.Speed(counter) = round(piezo_speed * Parameters.Vtodconversion * Parameters.attenuation * 1e9);
        
        %Place raw data results in a table
        raw_G.Conductance(counter) = Plateau_info(1).g_value;
        raw_G.FWHM(counter) = Plateau_info(1).FWHM;
        raw_G.Length(counter) = Plateau_info(1).length;
        raw_G.Name{counter} = Molecule{i};
        %Place high conductance results in a table
        high_G.Conductance(counter) = Plateau_info(high_class_idx(counter)).g_value;
        high_G.FWHM(counter) = Plateau_info(high_class_idx(counter)).FWHM;
        high_G.Length(counter) = Plateau_info(high_class_idx(counter)).length;
        high_G.Yield(counter) = Plateau_info(high_class_idx(counter)).yield;
        high_G.Name{counter} = Molecule{i};
        
        %Place low conductance results in a table
        try
        low_G_single.Conductance(counter) = Plateau_info(low_class_idx(counter)).g_value(end); %keeps the highest conductance plateau
        low_G_single.FWHM(counter) = Plateau_info(low_class_idx(counter)).FWHM(end);
        low_G_single.Length(counter) = Plateau_info(low_class_idx(counter)).length(1); %keeps the corresponding length (order of the two arrays is opposite
        low_G_single.Yield(counter) = Plateau_info(low_class_idx(counter)).yield;
        low_G_single.Name{counter} = Molecule{i};
        
        low_G.Conductance{counter} = Plateau_info(low_class_idx(counter)).g_value;
        low_G.FWHM{counter} = Plateau_info(low_class_idx(counter)).FWHM;
        low_G.Length{counter} = Plateau_info(low_class_idx(counter)).length;
        low_G.Yield(counter) = Plateau_info(low_class_idx(counter)).yield;
        low_G.Name{counter} = Molecule{i};
        catch
        low_G_single.Conductance(counter) = NaN; %keeps the highest conductance plateau
        low_G_single.FWHM(counter) = NaN;
        low_G_single.Length(counter) = NaN; %keeps the corresponding length (order of the two arrays is opposite
        low_G_single.Yield(counter) = NaN;
        low_G_single.Name{counter} = Molecule{i};
        
        low_G.Conductance{counter} = NaN;
        low_G.FWHM{counter} = NaN;
        low_G.Length{counter} = NaN;
        low_G.Yield(counter) = NaN;
        low_G.Name{counter} = Molecule{i};
        end
        counter = counter+1;
    end
end

%% Creates summary table

summary_raw_g = table('size',[length(Molecule),7],'VariableTypes',{'cell','double','double','double','double','double','double'},'VariableNames',{'Name','Conductance','G_std','FWHM','FWHM_std','Length','L_std'});
summary_high_g = table('size',[length(Molecule),7],'VariableTypes',{'cell','double','double','double','double','double','double'},'VariableNames',{'Name','Conductance','G_std','FWHM','FWHM_std','Length','L_std'});
summary_low_g = table('size',[length(Molecule),7],'VariableTypes',{'cell','cell','cell','cell','cell','cell','cell'},'VariableNames',{'Name','Conductance','G_std','FWHM','FWHM_std','Length','L_std'});
summary_low_g_single = table('size',[length(Molecule),7],'VariableTypes',{'cell','double','double','double','double','double','double'},'VariableNames',{'Name','Conductance','G_std','FWHM','FWHM_std','Length','L_std'});


for i=1:length(Molecule)
    %Raw data
    tmp = strcmp(raw_G.Name, Molecule{i}); %find array indeces in the table corresponding to the i-th label
    %computes mean and standard deviation of the data with the i-th label
    summary_raw_g.Conductance(i) = mean(raw_G.Conductance(tmp),'omitnan');
    summary_raw_g.G_std(i) = std(raw_G.Conductance(tmp),'omitnan');
    summary_raw_g.FWHM(i) = mean(raw_G.FWHM(tmp),'omitnan');
    summary_raw_g.FWHM_std(i) = std(raw_G.FWHM(tmp),'omitnan');
    summary_raw_g.Length(i) = mean(raw_G.Length(tmp),'omitnan');
    summary_raw_g.L_std(i) = std(raw_G.Length(tmp),'omitnan');
    summary_raw_g.Name{i} = Molecule{i};
    
    %High conductance
    tmp = strcmp(high_G.Name, Molecule{i}); %find array indeces in the table corresponding to the i-th label
    %computes mean and standard deviation of the data with the i-th label
    summary_high_g.Conductance(i) = mean(high_G.Conductance(tmp),'omitnan');
    summary_high_g.G_std(i) = std(high_G.Conductance(tmp),'omitnan');
    summary_high_g.FWHM(i) = mean(high_G.FWHM(tmp),'omitnan');
    summary_high_g.FWHM_std(i) = std(high_G.FWHM(tmp),'omitnan');
    summary_high_g.Length(i) = mean(high_G.Length(tmp),'omitnan');
    summary_high_g.L_std(i) = std(high_G.Length(tmp),'omitnan');
    summary_high_g.Name{i} = Molecule{i};
    
    %low conductance, taking only 1 peak per molecule
    tmp = strcmp(low_G_single.Name, Molecule{i}); %find array indeces in the table corresponding to the i-th label
    %computes mean and standard deviation of the data with the i-th label
    summary_low_g_single.Conductance(i) = mean(low_G_single.Conductance(tmp),'omitnan');
    summary_low_g_single.G_std(i) = std(low_G_single.Conductance(tmp),'omitnan');
    summary_low_g_single.FWHM(i) = mean(low_G_single.FWHM(tmp),'omitnan');
    summary_low_g_single.FWHM_std(i) = std(low_G_single.FWHM(tmp),'omitnan');
    summary_low_g_single.Length(i) = mean(low_G_single.Length(tmp),'omitnan');
    summary_low_g_single.L_std(i) = std(low_G_single.Length(tmp),'omitnan');
    summary_low_g_single.Name{i} = Molecule{i};

    %low conductance, taking all peaks per molecule
    tmp = strcmp(low_G.Name, Molecule{i}); %%find array indeces in the table corresponding to the i-th label, the cell2matr is needed to handle fits with 2 peaks
    %computes mean and standard deviation of the data with the i-th label
    %first, add nans to each cell array so that they all have the same
    %length (to avoid problems when measurements on the same molecule were
    %fitted with different number of peaks
    cond = low_G.Conductance(tmp);
    len = low_G.Length(tmp);
    width = low_G.FWHM(tmp);
    max = 1;
    for j = 1:length(cond)
        if length(cond{j})>max
            max = length(cond{j});
        end
    end
    for j = 1:length(cond)
        for k=1:(max-length(cond{j}))
            cond{j}=[cond{j} NaN];
            len{j}=[len{j} NaN];
            width{j}=[width{j} NaN];
        end
    end
    summary_low_g.Conductance{i} = mean(cell2mat(cond),'omitnan');
    summary_low_g.G_std{i} = std(cell2mat(cond),'omitnan');
    summary_low_g.FWHM{i} = mean(cell2mat(width),'omitnan');
    summary_low_g.FWHM_std{i} = std(cell2mat(width),'omitnan');
    summary_low_g.Length{i} = mean(cell2mat(len),'omitnan');
    summary_low_g.L_std{i} = std(cell2mat(len),'omitnan');
    summary_low_g.Name{i} = Molecule{i};
        
end

%% Save tables

if Save
    if  ~exist(savepath,'dir')
        mkdir(savepath)
    end
    writetable(raw_G,[savepath 'raw_data.xls'])
    writetable(high_G,[savepath 'high_G.xls'])
    writetable(low_G,[savepath 'low_G.xls'])
    writetable(low_G_single,[savepath 'low_G_single.xls'])
    writetable(summary_raw_g,[savepath 'summary_raw_data.xls'])
    writetable(summary_high_g,[savepath 'summary_high_G.xls'])
    writetable(summary_low_g,[savepath 'summary_low_G.xls'])
    writetable(summary_low_g_single,[savepath 'summary_low_G_single.xls'])
end
