%% 1D histogram comprison high conductance class, 1 measurement
close all
clear
clc

path = {'C:\Data\OPE3s\OPE3-diSAc\Sample 1\Molecule\15-19\scan190706_0\new scripts\3\',...
        'C:\Data\OPE3s\OPE3-diSAc\Sample 2\Molecule\16-20\scan190709_5\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Naphtalene\Sample 5\Molecule\13-17\scan190628_11\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Naphtalene\Sample 6\Molecule\13-17\scan190704_12\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Antracene\Sample 3\Molecule\3-7\scan190516_3\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Antracene\Sample 4\Molecule\15-19\scan190711_4\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - TetraCene\Sample 1\Molecule\3-7\scan190507_8\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - TetraCene\Sample 3\Molecule\15-19\scan190723_13\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Pentacene\Sample 1 piezo\molecule\16-20\scan190222_20\new scripts\3\',...
        'C:\Data\OPE3s\OPE3 - Pentacene\Sample 1 LC\Molecule\15-19\scan190702_14\new scripts\3\'};
name = {'scan190706_0','scan190709_5','scan190628_11','scan190704_12','scan190516_3','scan190711_4','scan190507_8','scan190723_13','scan190222_20','scan190702_14'};
class_idx = [4,2,...
             4,4,...
             4,4,...
             4,3,...
             4,5]; %this usually is class N +1, being index 1 the raw data

N_histo = [2 2 2 2 2]; %number of histograms for each molecule

%plot parameters
ymin = 5e-7;
ymax = 3;
countmax = 1.25;

%Savepath
Save = 1;
savepath = 'C:\Data\OPE3s\Plots for figures\Panel c\';
filename = 'Comparison_1D_histo';

%% Load data

[hist1D(:,1),yedges]=load1D(path{1},name{1},class_idx(1)); %load data from 1st measurement

[~,idx1] = min(abs(yedges-1e-6)); %Limits used to identify the range of interest over which to normalize
[~,idx2] = min(abs(yedges-3e-1)); %The maximum of the 1D histogram is found only looking at the range from -0.5 to -5.5 log10(G0) (approx.)
                               %This is to avoid noise level and normalize
                               %only over the relevant molecular range

hist1D(:,1)=hist1D(:,1)./max(hist1D(idx1:idx2,1)); %Rescale by maximum, for plotting comparison

for i=2:length(name)
    hist1D(:,i)=load1D(path{i},name{i},class_idx(i));
    hist1D(:,i)=hist1D(:,i)./max(hist1D(idx1:idx2,i)); %Rescale by maximum, for plotting comparison
end

%% Sum histograms correspondiong to the same molecule
hist1D_sum = zeros(length(yedges),length(N_histo));
counter = 1;
for i=1:length(N_histo)
    for j=1:N_histo(i)
        hist1D_sum(:,i) = hist1D_sum(:,i) + hist1D(:,counter); %sum all 1D histograms corresponding to the same molecule
        counter = counter+1;
    end
    hist1D_sum(:,i)=hist1D_sum(:,i)./max(hist1D_sum(idx1:idx2,i)); %Rescale by maximum, so that all peaks have the same height
end



%% Plot data

f = figure('Position',[10 10 1280 1060]);
ax1 = axes('Parent',f,'position',[.15 .15 .7 .7]);
hold on
set(gca,'box','on','linewidth',1.5)
col = linspecer(size(hist1D_sum,2));

for i=1:size(hist1D_sum,2)
    plot(yedges,hist1D_sum(:,i),'color',col(i,:),'linewidth',2);
end

set(gca,'xscale','log')
set(gca,'TickLength',[0.02, 0.002])
xlim([ymin,ymax])
ylim([0,countmax])
xlabel('Conductance [G_0]')
ylabel('Rescaled Counts [a.u.]')
set(gca,'XTick',[1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
legend({'OPE3','NP','9,10-AC','TC','PC'})
set(gca,'fontsize',24,'fontweight','normal')

%% Save
if Save
    SaveFigure(f, savepath, filename)
end