%test cross correlation plot

Gbin = length(Parameters.yedges);
corr = zeros(Gbin,Gbin);
norm = zeros(Gbin,1);


for i=1:10 %i=Files.plotstart:Files.plotend
    
     norm = norm + (Histograms(1).histo1Dsingle(i,:)-Histograms(1).histo1D).^2;

end

corr = cov(Histograms(1).histo1Dsingle);
norm = corrcoef(Histograms(1).histo1Dsingle);

final = corr./(norm*norm);

norm = norm/10;
corr = corr./sqrt(norm*norm');


        figure
        box on
        surf(log10(Parameters.yedges),log10(Parameters.yedges),norm,'edgecolor','interp');
        colormap(gca,cmap)
        view([0 90])
        set(gca,'linewidth',2);
        set(findall(gcf,'type','text'),'fontsize',24,'fontweight','normal')
        set(findall(gcf,'type','axes'),'fontsize',24,'fontweight','normal')
        f = gcf;
        oldunits = get(f,'Units');
        set(f, 'PaperUnits', 'centimeters', 'Units', 'centimeters');
        figpos = get(f, 'Position');
        f.PaperPositionMode = 'auto';
        set(gcf, 'PaperSize', figpos(3:4), 'Units', oldunits);
        xlabel('Conductance [log10(G/G_0)]')
        ylabel('Conductance [log10(G/G_0)]')
        xlim([log10(Parameters.Gmin),log10(Parameters.Gmax)]);
        ylim([log10(Parameters.Gmin),log10(Parameters.Gmax)]);