
V       =   0.1;        %V
Ghigh   =   3e-4;       %G0
Glow    =   5.6e-6;     %G0
G0      =   7.75e-5;    %S
JhighEgaIn = 1e-3;      %A/cm^2
rho     =   3e14;       % molec/cm2


w       =   100e-7;     %cm width of mcbj
t       =   80e-7;      %cm thickness of MCBJ
A       =   w*t;        %cm^2
density       =   1/A;      %molecules

J0      =   10^(-0.3);    %A/cm2
beta    =   0.23;       %A
d       =   20.27;      %A

rhocomp   =   JhighEgaIn/(Ghigh*G0 *V); %density of molecules that are required to make the EGaIn J from MCBJ conductance

Xi      = 0:0.01:0.99;

Jprist  =   J0*exp(-beta*d)*(1-Xi);    
Jpi     =   Glow*G0 *V *rho*(Xi);
Jhigh   =   Ghigh*G0 *V *rho;
Jpi2     =   Glow*G0 *V *rhocomp*(Xi);
Jpi3     =   Glow*G0 *V *density*(Xi);



figure
semilogy(Xi,Jprist+Jpi)
hold on
semilogy(Xi,Jprist+Jpi2)
semilogy(Xi,Jprist+Jpi3)
