%Plot 2D and 1D histogram as an inset

%NOTE: first load the workspace of the measurement to plot, then select the
%index of the class to plot, then

%fitting results (if any)
index = 1; %1 is raw data, see Histograms struct to decide which class to plot

Save=0; %saving histograms?

f_in=figure('Position',[10 10 1280 1060]);
    ax1 = axes('position',[.15 .15 .5 .8]); %2D histogram plot
        plot_2D(Histograms(index).histo2D,'none',Parameters.Dmin,Parameters.Dmax,Parameters.Gmin,Parameters.Gmax,Parameters.xedges,Parameters.yedges);
        colormap(cmap)
        set(gca,'linewidth',2);
        set(gca,'Fontsize',24);
        labpos = get(gca,'xlabel');
        colorbar off
    
    ax2=axes('Position',[.65 .15 .3 .8]); %1D histogram as inset
        plot_1D_free(Histograms(index).histo1D,Fits(index),Parameters) 
        view([90,-90])
        set(gca,'linewidth',2);
        set(gca,'YTickLabel',[]);
        set(gca,'XLabel',[]);
        yh=ylabel('Counts / trace [a.u.]');
        yh.Position(1) =  labpos.Position(2); 
        set(gca,'XTickLabel',[]);
        set(gca,'Fontsize',24);
    
set(findall(ax1,'type','text'),'fontsize',24,'fontweight','normal')  %change 2D histogram label font
%Save
if Save
    print(f_in,sprintf([Parameters.savepath 'figures/' Parameters.filename ' 2D_1D_side ' Histograms(index).name]),'-dpng','-r300');
    print(f_in,sprintf([Parameters.savepath 'figures/' Parameters.filename ' 2D_1D_side ' Histograms(index).name]),'-dtiffn','-r300');
    saveas(f_in,sprintf([Parameters.savepath 'figures/' Parameters.filename ' 2D_1D_side ' Histograms(index).name]));
    print(f_in,sprintf([Parameters.savepath 'figures/' Parameters.filename ' 2D_1D_side ' Histograms(index).name]),'-depsc','-r600');
    sprintf(['Figure saved in\n' savepath])
end

   
  
  