function [Histogram] = hist_length_cluster(Kmeans,Parameters,Files,Bools)
%Length histograms
%   Detailed explanation goes here

Gmax=1;
Gmin=1e-6;
Histogram = struct('Bins',{},'Counts',{},'Name',{});

if isstruct(Kmeans)
    for j=1:length(Kmeans)
        for i=1:length(Kmeans(j).d_breaking)
            %finds first and last point contained in the specified range
            xstart = find((Kmeans(j).g_breaking{i})<Gmax,1,'first');
            xend = find((Kmeans(j).g_breaking{i})>Gmin,1,'last');
            %calculate trace length between the two points
            Length{j}(i) = Kmeans(j).d_breaking{i}(xend)-Kmeans(j).d_breaking{i}(xstart);
            if Length {j}(i)<0
                Length {j}(i)=0;
            end
        end
            %generate histograms of the dataset
        Histogram(j).counts = hist(Length{j},Parameters.Ledges);
        Histogram(j).Counts = Histogram(j).counts ./ length(Kmeans(j).d_breaking);
    end



end

