function plot_1Dand2Dsidebyside(hist1D,hist2D,paper,Parameters,Bools)
	if nargin<3
		paper = 0;
	end
	
	load('color1.mat')	%Loads custom colormap used for 2D histo
	xedges = Parameters.xedges;
	yedges = Parameters.yedges;	
 	Dmin=min(xedges);
	Dmax=max(xedges);
 	Gmin=min(yedges);
 	Gmax=max(yedges);

	pos1 = find(min(abs(yedges - 1e-3)) == abs(yedges - 1e-3));
	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
	MAX = max(max(hist2D(pos2:pos1,:)))/2;

	f1=figure('Position',[300 150 900 775],'PaperPositionMode','auto');
	h1=subplot(1,2,1);
	
	if paper	
		f2=figure('Position',[300 150 900 775],'PaperPositionMode','auto');
		axes('Position', [0.125, 0.1, 0.45, 0.85]);

		surf(xedges,yedges,hist2D,'edgecolor','interp');	% If you are importing data that was plotted with a different Dbin you have to recreate the 2D histogram by initializing it and running the 'Breaking traces alignement & histo creation' segment 
		view([0 90])
		set(gca,'YScale','log')
		colormap(gca,cmap)
		caxis([0 MAX])
		set(gca,'Xlim',[Dmin Dmax])
		%set(gca,'Xlim',[-0.5 2.5])
		%set(gca,'Ylim',[Gmin 3])
		set(gca,'Ylim',[5e-7 3])
		set(gca,'visible','off')

		%now that we're done with the 2D histo we can go back to making its
		%axes and the 1D histo
		figure(f1)
	else
		surf(xedges,yedges,hist2D,'edgecolor','interp');	% If you are importing data that was plotted with a different Dbin you have to recreate the 2D histogram by initializing it and running the 'Breaking traces alignement & histo creation' segment
		view([0 90])
	end
	
	set(gca,'YScale','log')
	colormap(gca,cmap)
	caxis([0 MAX])
	c=colorbar('north');	% 'east' 'north'
	drawnow; % if the colorbar is not drawn at this point the tick labels end above the bar
	set(c,'Position',[0.275 0.85 0.275 0.033]); % for 'north'
	%set(c,'Position',[0.43 0.45 0.025 0.4]); %for 'east'

	xlabel('Electrode displacement (nm)')
	ylabel('Conductance (G_0)')
	set(gca,'Xlim',[Dmin Dmax])
   %set(gca,'Xlim',[-0.5 2.5])
	%set(gca,'Ylim',[Gmin 3])
	set(gca,'Ylim',[5e-7 3])
	%set(gca,'YTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
	set(gca,'YTick',[1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
	set(get(c,'title'),'String','Counts/trace','fontsize',16,'fontweight','normal');
	%title('Bare Au')
	set(gca,'fontsize',20,'fontweight','normal')
	set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
	set(gca,'linewidth',1,'box','on');
	set(gca,'Tickdir','in','Layer','top','XGrid','off','YGrid','off')
	set(gcf,'color','white')

	h2=subplot(1,2,2);
   pos1 = find(min(abs(yedges - 3)) == abs(yedges - 3));
 	pos2 = find(min(abs(yedges - 1e-6)) == abs(yedges - 1e-6));
 	MAX = max(hist1D(pos2:pos1));

	semilogy(hist1D,yedges);
	%ylabel('Conductance / G_0')
	xlabel('Counts / trace')
	set(gca,'fontsize',20,'fontweight','normal')
	set(findall(gcf,'type','text'),'fontsize',20,'fontweight','normal')
	set(gca,'linewidth',1,'box','on')
	set(gcf,'color','white')
	set(gca,'Ylim',[5e-7 3])
	set(gca,'Yticklabel',[])
	%set(gca,'Ylim',[10^Gmin  3])
	set(gca,'Xlim',[0 1.05*MAX])
	set(gca,'Xticklabel',[])
	%set(gca,'XTick',10.^linspace(Gmin,Gmax,Gmax-Gmin+1))
	set(gca,'YTick',[1e-8 1e-7 1e-6 1e-5 1e-4 1e-3 1e-2 1e-1 1])
	
	set(h1,'Position', [0.125, 0.1, 0.45, 0.85])	% if I immediately put h1 here, creating subplot h2 will delete h1 because they overlap
	pos = get(h1,'position');
	set(h2,'Position', [pos(1)+pos(3), pos(2), pos(3)*0.85, pos(4)])
	
	
	if Bools.Save
		savepath = Parameters.savepath;
		filename = Parameters.filename;
		name = inputname(2);	% Gets the name of the second argument passed at the function
		name = name(5:end);	% Gets rid of the leading 'hist' in the variable name, so effectively only 2D or 2D_mol et similia will remain
		if paper
			saveas(f1,[savepath filename '_G_1Dand' name '_sidebyside_axes.eps'],'psc2')
			saveas(f2,[savepath filename '_G_1Dand' name '_sidebyside_plot.tif'])
		else
			print(f1,[savepath filename '_G_1Dand' name '_sidebyside'],'-dpng','-r0')
		end
	end
	
	disp('Side by side histograms saved!')
	
	close(f1)
	if paper
		close(f2)
	end
end
